/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { m_revit = commandData.Application.Application; Transaction documentTransaction = new Transaction(commandData.Application.ActiveUIDocument.Document, "Document"); documentTransaction.Start(); // Initialize the helper classes. m_combinationDeal = new LoadCombinationDeal(this); m_loadCaseDeal = new LoadCaseDeal(this); // Prepare some data for the form displaying PrepareData(); // Display the form and wait for the user's operate. // This class give some public methods to add or delete LoadUsage and delete LoadCombination // The form will use these methods to add or delete dynamically. // If the user press cancel button, return Cancelled to roll back All the changes. using (LoadsForm displayForm = new LoadsForm(this)) { if (DialogResult.OK != displayForm.ShowDialog()) { documentTransaction.RollBack(); return(Autodesk.Revit.UI.Result.Cancelled); } } // If everything goes right, return succeeded. documentTransaction.Commit(); return(Autodesk.Revit.UI.Result.Succeeded); }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { m_revit = commandData.Application.Application; Transaction documentTransaction = new Transaction(commandData.Application.ActiveUIDocument.Document, "Document"); documentTransaction.Start(); // Initialize the helper classes. m_combinationDeal = new LoadCombinationDeal(this); m_loadCaseDeal = new LoadCaseDeal(this); // Prepare some data for the form displaying PrepareData(); // Display the form and wait for the user's operate. // This class give some public methods to add or delete LoadUsage and delete LoadCombination // The form will use these methods to add or delete dynamically. // If the user press cancel button, return Cancelled to roll back All the changes. using (LoadsForm displayForm = new LoadsForm(this)) { if (DialogResult.OK != displayForm.ShowDialog()) { documentTransaction.RollBack(); return Autodesk.Revit.UI.Result.Cancelled; } } // If everything goes right, return succeeded. documentTransaction.Commit(); return Autodesk.Revit.UI.Result.Succeeded; }